package application;

/*
 *  Copyright (C) 2018 Juergen Platzer 
 * 
 *  This file is part of JInfoViz.
 *  
 *  JInfoViz is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *  
 *  JInfoViz is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *  
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with JInfoViz.  If not, see <http://www.gnu.org/licenses/>.
 */



import javax.swing.UIManager;
import java.awt.*;



/**
*
*  Class containing the main method for starting the program.
*
*/
public class ParCoord {
  
  /*** member variables ***/
  boolean m_bPackFrame = false;

/**
*
*  Constructs the application.
*
*  The method instantiates a new Mainframe object and shows the generated window centered on
*  the screen.
*/
  public ParCoord() {
    
    //1. create the main frame of the application
    Mainframe pFrame = new Mainframe();
    //Validate frames that have preset sizes
    //Pack frames that have useful preferred size info, e.g. from their layout
    if (m_bPackFrame) {
      pFrame.pack();
    }
    else {
      pFrame.validate();
    }
    
    
    //2. Center the window and show it
    Dimension pScreenSize = Toolkit.getDefaultToolkit().getScreenSize();
    Dimension pFrameSize = pFrame.getSize();
    if (pFrameSize.height > pScreenSize.height) {
      pFrameSize.height = pScreenSize.height;
    }
    if (pFrameSize.width > pScreenSize.width) {
      pFrameSize.width = pScreenSize.width;
    }
    pFrame.setLocation((pScreenSize.width - pFrameSize.width)/2, (pScreenSize.height - pFrameSize.height) / 2);
    
    pFrame.setVisible(true);

  }


/**
*
*  Creates a new ParCoord object.
*
*/
  public static void main(String[] args) {
    //1. set the look and feel of the system
    try {
      UIManager.setLookAndFeel(UIManager.getSystemLookAndFeelClassName());
    }
    catch(Exception e) {
      e.printStackTrace();
    }
    
    //2. start the application
    new ParCoord();
  }
}