package listeners;

/*
 *  Copyright (C) 2018 Juergen Platzer 
 * 
 *  This file is part of JInfoViz.
 *  
 *  JInfoViz is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *  
 *  JInfoViz is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *  
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with JInfoViz.  If not, see <http://www.gnu.org/licenses/>.
 */


import data.Data;
import view.ColorTransition;

import java.awt.Color;

public interface IViewColoring {


  /* returns an integer array with the IDs of the data items.
     the first ID in the array should be drawn first and appears in the background.
     the last ID in the array should be drawn as last item and appears in the front.*/
  public int[] getRenderPositions(Data pData);


  /* returns an array of colors for the data items ordered by the render position */
  public Color[] getRenderColors(Data pData);


  /* for SelectionColoring: a new doi changes the colors of the data items */
  public void updateDOI(float[] pDOI);


  /* set a new startcolor
  /*public void setStartColor(Color start);

  /* set a new endcolor
  public void setEndColor(Color end);*/

  /* sets a new color transition */
  public void setColorTransition(ColorTransition pColorTransition);

  /* set the necessary color properties */
  public void setColoringProperties(Color pNotSelected, Color pSelected, ColorTransition pColorTransition);


}