package tools;

/*
 *  Copyright (C) 2018 Juergen Platzer 
 * 
 *  This file is part of JInfoViz.
 *  
 *  JInfoViz is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *  
 *  JInfoViz is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *  
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with JInfoViz.  If not, see <http://www.gnu.org/licenses/>.
 */

public class IndexAndValue implements Comparable<IndexAndValue> {

  /*** member variables ***/
  private int    m_iIndex;
  private float  m_fValue;

  
  /////////////////////////
  // CONSTRUCTOR         //
  /////////////////////////
  public IndexAndValue(int iIndex, float fValue) {
    m_iIndex = iIndex;
    m_fValue = fValue;
  }

  
  /////////////////////////////
  // COMPARABLE INTERFACE    //
  /////////////////////////////
  public int compareTo(IndexAndValue pOtherIndexAndValue) throws ClassCastException {
    //1. make a simple check
    if (pOtherIndexAndValue == null) return 1;
    

    //2. make the comparison
    float fOtherValue = pOtherIndexAndValue.getValue();
    
    if (m_fValue == fOtherValue) return 0;
    if (m_fValue < fOtherValue) return -1;
    return 1;
  }
  
  
  /////////////////////////////////
  // GET METHODS                 //
  /////////////////////////////////
  public float getValue() {
    return m_fValue;
  }
  
  public int getIndex() {
    return m_iIndex;
  }

}