package tools;

/*
 *  Copyright (C) 2018 Juergen Platzer 
 * 
 *  This file is part of JInfoViz.
 *  
 *  JInfoViz is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *  
 *  JInfoViz is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *  
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with JInfoViz.  If not, see <http://www.gnu.org/licenses/>.
 */

public class ValueAndVector implements Comparable<ValueAndVector> {

  /** member variables ***/
  private float    m_fValue;
  private float[]  m_pVector;

  
  ////////////////////////
  // CONSTRUCTOR        //
  ////////////////////////
  public ValueAndVector(float fValue, float[] pVector) {
    m_fValue = fValue;
    m_pVector = pVector;
  }
  
  
  /////////////////////////
  // GET METHODS         //
  /////////////////////////
  public float getValue() {
    return m_fValue;
  }
  
  public float[] getVector() {
    return m_pVector;
  }
  
  public String toString() {
    float fCurrValue = (float)((int)(m_fValue*1000))/1000;

    String pString = "Value: " + fCurrValue + "   Vector: (";

    int iEntryNum = m_pVector.length;
    for (int i = 0; i < iEntryNum; i++) {
      fCurrValue = (float)((int)(m_pVector[i]*1000))/1000;
      if (i < iEntryNum-1) {
        pString += fCurrValue + ", ";
      }
      else {
        pString += fCurrValue + ")";
      }
    }

    return pString;
  }


  
  //////////////////////////
  // COMPARABLE INTERFACE //
  //////////////////////////
  public int compareTo(ValueAndVector pValueAndVector) throws ClassCastException {
    //1. make some checks
    if (pValueAndVector == null) return 1;

    float fOtherValue = pValueAndVector.getValue();
    if (m_fValue == fOtherValue) return 0;
    if (m_fValue < fOtherValue) return -1;

    return 1;
  }


  
}